module Pentest
  class Checkers
    @checkers = []

    class << self
      def add(checker)
        @checkers << checker unless @checkers.include? checker
      end

      def run_checkers(endpoint, params)
        @checkers.each do |checker_class|
          checker = checker_class.new(endpoint, params)
          yield(checker)
        end
      end
    end
  end
end

require 'pentest/checkers/sqli_checker'
require 'pentest/checkers/xss_checker'