require 'optparse'

module Pentest
  # Implements Command-Line Interface of Pentest

  class Commandline
    class << self
      # Runs everything:
      def run default_app_path = "."
        options, args = get_options

        if args.size >= 1
          options[:app_path] = args[0]
        else
          options[:app_path] = default_app_path
        end

        result = Pentest.run options.merge(:print_report => true)

        if result.nil?
          exit 0
        else
          exit 1
        end
      end

      def get_options
        options = {}
        parser = create_option_parser options
        args = parser.parse! ARGV
        [options, args]
      end

      def create_option_parser options
        OptionParser.new do |opts|
          opts.banner = "Usage: pentest [options] rails/root/path"
        end
      end
    end
  end
end
